searchData={"items":[{"type":"module","title":"Paradex","doc":"A collection of macros for composing ParadeDB queries.","ref":"Paradex.html"},{"type":"macro","title":"Paradex.all/0","doc":"Macro for [paradedb.all](https://docs.paradedb.com/documentation/advanced/compound/all).\n\n    from(\n      c in Call,\n      where: c.id ~> all()\n    )","ref":"Paradex.html#all/0"},{"type":"macro","title":"Paradex.boolean/3","doc":"Macro for [paradedb.boolean](https://docs.paradedb.com/documentation/advanced/compound/boolean).\n\nEach value must be a query object, or a list of query objects.","ref":"Paradex.html#boolean/3"},{"type":"macro","title":"Paradex.boost/2","doc":"Macro for [paradedb.boost](https://docs.paradedb.com/documentation/advanced/compound/boost).\n\n    from(\n      c in Call,\n      select: {c. score(c.id)},\n      boost(2.0, \"transcript:bus\")\n    )","ref":"Paradex.html#boost/2"},{"type":"macro","title":"Paradex.const_score/2","doc":"Macro for [paradedb.const_score](https://docs.paradedb.com/documentation/advanced/compound/const).\n\n    from(\n      c in Call,\n      select: {c, score(c.id)},\n      where: c.id ~> const_score(2.0, parse(\"transcript:bus\"))\n    )","ref":"Paradex.html#const_score/2"},{"type":"macro","title":"Paradex.daterange/4","doc":"Macro for [paradedb.range](https://docs.paradedb.com/documentation/advanced/term/range) using the `date` data type.\n\n    start = ~D[2024-10-09]\n    stop = ~D[2024-10-10]\n\n    query =\n      from(\n        c in Call,\n        where: c.id ~> daterange(\"start_time\", ^start, ^stop, \"[]\")\n      )","ref":"Paradex.html#daterange/4"},{"type":"macro","title":"Paradex.disjunction_max/2","doc":"Macro for [paradedb.disjunction_max](https://docs.paradedb.com/documentation/advanced/compound/disjunction_max)\n\n    from(\n      c in Call,\n      where:\n        c.id ~> disjunction_max([\n          parse(\"transcript:bus\"),\n          int4range(\"call_length\", 10, nil, \"[)\")\n        ])\n    )","ref":"Paradex.html#disjunction_max/2"},{"type":"macro","title":"Paradex.empty/0","doc":"Macro for [paradedb.empty](https://docs.paradedb.com/documentation/advanced/compound/empty)\n\n    from(\n      c in Call,\n      where: c.id ~> empty()\n    )","ref":"Paradex.html#empty/0"},{"type":"macro","title":"Paradex.fuzzy_phrase/6","doc":"Macro for [paradedb.fuzzy_phrase](https://docs.paradedb.com/documentation/advanced/phrase/fuzzy_phrase).\n\n    from(\n      c in Call,\n      where: c.id ~> fuzzy_phrase(\"transcript\", \"bus sotp\")\n    )","ref":"Paradex.html#fuzzy_phrase/6"},{"type":"macro","title":"Paradex.fuzzy_term/5","doc":"Macro for [paradedb.fuzzy_term](https://docs.paradedb.com/documentation/advanced/term/fuzzy_term).\n\n    from(\n      c in Call,\n      where: c.id ~> fuzzy_term(\"transcript\", \"bus\", 2, true, false)\n    )","ref":"Paradex.html#fuzzy_term/5"},{"type":"macro","title":"Paradex.int4range/4","doc":"Macro for [paradedb.range](https://docs.paradedb.com/documentation/advanced/term/range) using the `int4` data type.\n\n    from(\n      c in Call,\n      where: c.id ~> int4range(\"call_length\", 5, nil, \"[)\")\n    )","ref":"Paradex.html#int4range/4"},{"type":"macro","title":"Paradex.int8range/4","doc":"Macro for [paradedb.range](https://docs.paradedb.com/documentation/advanced/term/range) using the `int8` data type.\n\n    from(\n      c in Call,\n      where: c.id ~> int8range(\"call_length\", 5, nil, \"[)\")\n    )","ref":"Paradex.html#int8range/4"},{"type":"macro","title":"Paradex.parse/1","doc":"Macro for [paradedb.parse](https://docs.paradedb.com/documentation/advanced/compound/parse)\n\n    from(\n      c in Call,\n      where: c.id ~> parse(\"transcript:bus\")\n    )","ref":"Paradex.html#parse/1"},{"type":"macro","title":"Paradex.parse_with_field/3","doc":"Macro for [paradedb.parse_with_field](https://docs.paradedb.com/documentation/advanced/compound/parse#parse-with-field)\n\n    from(\n      c in Call,\n      where: c.id ~> parse_with_field(\"transcript\", \"traffic congestion\")\n    )","ref":"Paradex.html#parse_with_field/3"},{"type":"macro","title":"Paradex.pdb_exists/1","doc":"Macro for [paradedb.exists](https://docs.paradedb.com/documentation/advanced/term/exists#exists). Prefixed with `pdb_` to avoid conflicting with `Ecto.Query.API.exists/1`.\n\n    from(\n      c in Call,\n      where: c.id ~> pdb_exists(\"call_length\")\n    )","ref":"Paradex.html#pdb_exists/1"},{"type":"macro","title":"Paradex.phrase/3","doc":"Macro for [paradedb.phrase](https://docs.paradedb.com/documentation/advanced/phrase/phrase)\n\n    from(\n      c in Call,\n      where: c.id ~> phrase(\"transcript\", [\"bus\", \"stop\"], 1)\n    )","ref":"Paradex.html#phrase/3"},{"type":"macro","title":"Paradex.phrase_prefix/3","doc":"Macro for [paradedb.phrase_prefix](https://docs.paradedb.com/documentation/advanced/phrase/phrase_prefix)\n\n    from(\n      c in Call,\n      where: c.id ~> phrase_prefix(\"transcript\", [\"en\"])\n    )","ref":"Paradex.html#phrase_prefix/3"},{"type":"macro","title":"Paradex.range_term/2","doc":"Macro for [paradedb.range_term](https://docs.paradedb.com/documentation/advanced/term/range_term)","ref":"Paradex.html#range_term/2"},{"type":"macro","title":"Paradex.regex/2","doc":"Macro for [paradedb.regex](https://docs.paradedb.com/documentation/advanced/term/regex). Be mindful that these regular expressions follow [Tantivy's syntax](https://docs.rs/tantivy-fst/latest/tantivy_fst/struct.Regex.html), which follows Rust's regex crate with a few variations.\n\n    from(\n      c in Call,\n      where: c.id ~> regex(\"transcript\", \"(stop|route)\")\n    )","ref":"Paradex.html#regex/2"},{"type":"macro","title":"Paradex.score/0","doc":"","ref":"Paradex.html#score/0"},{"type":"macro","title":"Paradex.score/1","doc":"Returns the BM25 search score for each result, aliasing it as `pdb_score` in the query. Can be used with `score/0` to order results:\n\n    from(\n      c in Call,\n      select: {c, score(c.id)},\n      where: c.transcript ~> \"mechanic\",\n      order_by: [desc: score()]\n    )","ref":"Paradex.html#score/1"},{"type":"macro","title":"Paradex.score_as/1","doc":"","ref":"Paradex.html#score_as/1"},{"type":"macro","title":"Paradex.score_as/2","doc":"Same as `score/1` but uses a variable for the alias instead. Does not support literals.\n\n    score_alias = \"my_score\"\n\n    from(\n      c in Call,\n      select: {c, score_as(c.id, ^score_alias)},\n      where: c.transcript ~> \"mechanic\",\n      order_by: [desc: score_as(^score_alias)]\n    )","ref":"Paradex.html#score_as/2"},{"type":"macro","title":"Paradex.snippet/4","doc":"Macro for [paradedb.snippet](https://docs.paradedb.com/documentation/full-text/highlighting), used for highlighting.\n\n    from(\n      c in Call,\n      select: {c, snippet(c.transcript)},\n      where: c.transcript ~> \"mechanic\"\n    )","ref":"Paradex.html#snippet/4"},{"type":"macro","title":"Paradex.term/2","doc":"Macro for [paradedb.term](https://docs.paradedb.com/documentation/advanced/term/term)\n\n    from(\n      c in Call,\n      where: c.id ~> term(\"talkgroup_num\", 7695)\n    )","ref":"Paradex.html#term/2"},{"type":"macro","title":"Paradex.term_set/1","doc":"Macro for [paradedb.term_set](https://docs.paradedb.com/documentation/advanced/term/term_set)\n\n    from(\n      c in Call,\n      where: c.id ~> term_set([\n        term(\"talkgroup_num\", 7700),\n        term(\"call_length\", 20)\n      ])\n    )","ref":"Paradex.html#term_set/1"},{"type":"macro","title":"Paradex.tsrange/4","doc":"Macro for [paradedb.range](https://docs.paradedb.com/documentation/advanced/term/range) using the `timestamp` data type.\n\n    begin = ~U[2024-10-09 08:00:00.00Z]\n\n    query =\n      from(\n        c in Call,\n        where: c.id ~> tsrange(\"start_time\", ^begin, nil, \"[)\")\n      )","ref":"Paradex.html#tsrange/4"},{"type":"macro","title":"Paradex.~>/2","doc":"Macro for the [`@@@`](https://docs.paradedb.com/documentation/full-text/overview#basic-usage) full text search operator.\n\n`~>` is used as it's one of a few infix operators Elixir's capable of parsing, but aren't presently used.","ref":"Paradex.html#~%3E/2"},{"type":"macro","title":"Examples - Paradex.~>/2","doc":"Search queries can be run on fields directly:\n    import Paradex\n\n    from(\n      c in Call,\n      where: c.transcript ~> \"bus\"\n    )\n\nAlternatively a key field and query object can be used for advanced queries:\n\n    from(\n      c in Call,\n      where: c.id ~> disjunction_max([\n        parse(\"transcript:bus\"),\n        int4range(\"call_length\", 10, nil, \"[)\")\n      ])\n    )","ref":"Paradex.html#~%3E/2-examples"},{"type":"extras","title":"Paradex","doc":"# Paradex\n\nEcto fragments for [ParadeDB](https://www.paradedb.com/), currently under active development.","ref":"readme.html"},{"type":"extras","title":"Installation - Paradex","doc":"Add `:paradex` to your list of dependencies in `mix.exs`:\n\n<!-- BEGIN: VERSION -->\n```elixir\ndef deps do\n  [\n    {:paradex, \"~> 0.0.1\"}\n  ]\nend\n```\n<!-- END: VERSION -->\n\nDocumentation is available on [HexDocs](https://hexdocs.pm/paradex/readme.html) and may also be generated with [ExDoc](https://github.com/elixir-lang/ex_doc).","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Paradex","doc":"* Create your [Ecto schema](https://github.com/Moosieus/paradex/blob/main/test/support/paradex_app/call.ex).\n* Create a [search index](https://docs.paradedb.com/documentation/indexing/create_index) in your [migrations](https://github.com/Moosieus/paradex/blob/main/priv/repo/migrations/20241013014316_setup.exs).\n* Run search queries.\n\n```elixir\nimport Ecto.Query\nimport Paradex\n\nalias MyApp.Call\nalias MyApp.Repo\n\nfrom(\n  c in Call,\n  where: c.transcript ~> \"bus\"\n)\n|> Repo.all()\n```\n\nMore examples are available in the [API docs](https://hexdocs.pm/paradex/Paradex.html).","ref":"readme.html#usage"},{"type":"extras","title":"Roadmap/Todo - Paradex","doc":"* Add examples for `range_term/2` and `boolean/3`\n* Add test coverage for `range_term/2` and `boolean/3`\n* Implement [more_like_this](https://docs.paradedb.com/documentation/advanced/specialized/more_like_this).\n* Implement facets and aggregations (currently enterprise features).\n* Implement hybrid search, or add a guide for users to do so themselves.","ref":"readme.html#roadmap-todo"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}